package com.yidian.yac.newscontent.http

import com.yidian.common.http.HttpResult
import com.yidian.yac.newscontent.http.httpbean.AppInitBean
import io.reactivex.rxjava3.core.Observable
import okhttp3.MultipartBody
import retrofit2.http.*

interface CommonService {
    @POST(URLs.init)
    fun appInit(@QueryMap commonParams: Map<String, String>,@Body requestParams: AppInitBean.Request): Observable<HttpResult<String?>>

    @Multipart
    @POST(URLs.uploadFile)
    fun uploadFile(@QueryMap commonParams: Map<String, String>, @Part part: MultipartBody.Part): Observable<HttpResult<Any?>>
}